program testdelphi;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  xidcusb;

type
        XidcException = class(Exception);

procedure ShowState(dev: Device);
var
        res: XidcResult;
        state: xidcusb.State;
begin
        res := get_status(dev, state);
        if res <> ResultOk then
                raise XidcException.Create('Result ' + IntToStr(res));
        WriteLn(
                'state: ' + IntToStr(state.device_state) +
                ' pwm: ' + IntToStr(state.pwm_state) +
                ' rpm: ' + IntToStr(state.current_rpm) +
                ' pos: ' + IntToStr(state.current_position) +
                ' temp: ' + IntToStr(state.current_temp) +
                ' flags: ' + IntToStr(state.flags));
end;

procedure Test;
var
        res: XidcResult;
        dev: Device;
        device_names: StringArray;
begin
        WriteLn('Hello');
        dev := DeviceUndefined;
        device_names := nil;

        try
                device_names := enumerate_devices(1);
                WriteLn('Found devices... ', Length(device_names));
                if Length(device_names) = 0 then
                        raise XidcException.Create('No devices found');

                WriteLn('Using device ', device_names[0]);
                //dev := open_device('\\.\COM8');
                dev := open_device(PAnsiChar(device_names[0]));
                if (dev = DeviceUndefined) then
                        raise XidcException.Create('No such device');
                WriteLn('Device is ', dev);
                ShowState(dev);

                WriteLn('Running...');
                res := command_right(dev);
                if (res <> ResultOk) then
                        raise XidcException.Create('Error command ' + IntToStr(res));

                Sleep(1*1000);
                ShowState(dev);
                Sleep(10*1000);
                ShowState(dev);

                WriteLn('Stopping...');
                res := command_stop(dev);
                if (res <> ResultOk) then
                        raise XidcException.Create('Error command ' + IntToStr(res));
                ShowState(dev);

                close_device(dev);
        except
                on exc: XidcException do begin
                        WriteLn('Error happens ', exc.Message);
                        if dev <> DeviceUndefined then
                                close_device(dev);
                end
        end;
        WriteLn('Done...');
        ReadLn;
end;

begin
        Test;
end.
